package com.codegeist.fisheye.internal.core.connection;

import java.io.File;

import org.junit.Before;
import org.junit.Test;

// TODO finish this off with tests for invalid stores
// TODO assert file is being saved correctly
public class FisheyeConnectionStorageTest {

	private FisheyeConnectionManager manager;
	private File tmpDir = new File(System.getProperty("java.io.tmpdir"));
	
	@Before
	public void setup() {
		manager = new FisheyeConnectionManager();
	}
	
	@Test
	public void testLoad() {
		String location = FisheyeConnectionStorageTest.class.getClassLoader().getResource("connections.xml").getFile();
		File stateFile = new File(location);
		File stateLocation = stateFile.getParentFile();
		
		FisheyeConnectionStorage storage = new FisheyeConnectionStorage(manager, stateLocation);
		storage.load();
	}
	
	@Test
	public void testStore() {
		String location = FisheyeConnectionStorageTest.class.getClassLoader().getResource("connections.xml").getFile();
		File stateFile = new File(location);
		File stateLocation = stateFile.getParentFile();
		
		FisheyeConnectionStorage storage = new FisheyeConnectionStorage(manager, stateLocation);
		storage.load();
		
		File tmpLocation = new File(tmpDir, "testStore");
		tmpLocation.mkdirs();
		
		storage = new FisheyeConnectionStorage(manager, tmpLocation);
		
		storage.store();
		
		new File(tmpLocation, "connections.xml").delete();
		tmpLocation.delete();
	}
}
