package com.codegeist.fisheye.internal.service;

import java.util.ArrayList;
import java.util.List;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class StringArrayHandler extends DefaultHandler implements Handler<String[]>{
	private StringBuilder buffer = new StringBuilder();
	private List<String> resultList = new ArrayList<String>();
	private String[] result;
	
	@Override
	public void startDocument() throws SAXException {
	}

	@Override
	public void startElement(String uri, String localName, String name, Attributes attributes) throws SAXException {
		buffer.setLength(0);
	}
	
	@Override
	public void endElement(String uri, String localName, String name) throws SAXException {
		if ("string".equals(localName)) {
			resultList.add(buffer.toString());
		}
		buffer.setLength(0);
	}
	
	
	@Override
	public void endDocument() throws SAXException {
		result = resultList.toArray(new String[resultList.size()]);
	}
	
	@Override
	public void characters(char[] ch, int start, int length) throws SAXException {
		buffer.append(ch, start, length);
	}
	
	public String[] getResult() {
		// TODO check that the result is ok
		return result;
	}
}
